var gGCContactManager = {
	SYNC_MODE_INTERACTIVE: 0,
	SYNC_MODE_BATCH: 1,
	SYNC_MODE_READONLY: 2,
	contactsList: [],
	listeningABs: [],
	googleABs: [],
	updatedFromOffline: false,
	initDone: false,
	firstSyncDone: false,
	localeBundle: null,
	queueNum: 0,
	syncMode: 0, //0: interactive, 1: batch, 2: read only
	batchCount: 0,
	lockModEvent: false,
	uninstallObserver: null,
	timerId: null,
	listenerStopCount: 0,
	listenerWorking: false,
	pendingContacts: [],
	pendingContactsForPhotos: [],
	photoManager: null,
	pref: Components.classes['@mozilla.org/preferences;1'].
	  						getService(Components.interfaces.nsIPrefBranch),
	//abSession: Components.classes["@mozilla.org/addressbook/services/session;1"].
	//						getService().QueryInterface(Components.interfaces.nsIAddrBookSession),
	abSession: Components.classes["@mozilla.org/abmanager;1"].
							getService().QueryInterface(Components.interfaces.nsIAbManager),

	//nsIAbListener
	onItemAdded: function(parentDir, item) {
		/*
		var me = this;
		var func = function() {
			me.onItemAddedFunc(parentDir, item);
		};
		setTimeout(func);
		*/
		this.onItemAddedFunc(parentDir, item);
	},
  onItemAddedFunc: function(parentDir, item) {
  	gGCLogger.dump("Detect add\n");
  	if (this.syncMode == this.SYNC_MODE_READONLY) {
  		var msg = this.localeBundle.getString("gmcont.readonly_warn");
  		this.outputMessageToStatusBar(msg);
  		gGCLogger.dump("Read only mode. Ignore changes\n");
  		return;
  	}

  	var uri = null;
  	try {
	    //var dir = parentDir.QueryInterface(Components.interfaces.nsIAbMDBDirectory);
   		//uri = dir.getDirUri();
  		var dir = parentDir.QueryInterface(Components.interfaces.nsIAbDirectory);
   		uri = dir.URI;
   		var contacts = this.contactsList[uri];
   		if (!contacts) return;
    	var card = item.QueryInterface(Components.interfaces.nsIAbCard);
	   	if (!card.isMailList) {
  			//var msec = (new Date()).getTime();
		  	//this.lockModEvent = true;
 				//card.lastModifiedDate = parseInt(msec/1000);
	 			//card.editCardToDatabase(uri);
				//this.lockModEvent = false;
    		if (!this.listening(uri)) return;
    		if (this.syncMode == this.SYNC_MODE_BATCH) this.writeToOfflineLog(contacts, contacts.account, uri, card, "ADD", true);
    		if (this.syncMode == this.SYNC_MODE_INTERACTIVE) contacts.updateContact(card);
    	} else {
    		gGCLogger.dump("list card is added. ignore.\n");
    	}
    }catch(e){
    	try {
//    		if (!uri) return;
	   		if (!contacts) return;
    		var list = item.QueryInterface(Components.interfaces.nsIAbDirectory);
    		if (list.isMailList) {
 					if (!contacts.isGroupMappingEnabled()) {
 						//this.updateLastModifiedDateForMailList(list, null, contacts.account);
	 					//if (this.syncMode != this.SYNC_MODE_INTERACTIVE) return;
		    		if (this.syncMode == this.SYNC_MODE_BATCH) this.writeToOfflineLog(contacts, contacts.account, uri, list, "ADD", false);
			   		if (!this.listening(uri)) return;
	    			if (this.syncMode == this.SYNC_MODE_INTERACTIVE) contacts.updateGroup(list);
    				//if (contacts && this.listening(uri)) contacts.updateGroup(list);
 					}
    		}	else {
    			gGCLogger.dump("added item is ab. ignore\n");
    		}
    	} catch(e) {
    		gGCLogger.dump(e+"\n");
    	}
    }
  },
  onItemRemoved: function(parentDir, item) {
  	/*
  	var me = this;
  	var func = function() {
  		me.onItemRemovedFunc(parentDir, item);
  	};
  	setTimeout(func);
  	*/
  	this.onItemRemovedFunc(parentDir, item);
  },
  onItemRemovedFunc: function(parentDir, item) {
  	gGCLogger.dump("Detect remove\n");
  	if (this.syncMode == this.SYNC_MODE_READONLY) {
  		var msg = this.localeBundle.getString("gmcont.readonly_warn");
  		this.outputMessageToStatusBar(msg);
  		gGCLogger.dump("Read only mode. Ignore changes\n");
  		return;
  	}
  	var pdir = null;
  	try { //card
	  	pdir = parentDir.QueryInterface(Components.interfaces.nsIAbMDBDirectory);
	  	var contacts = null;
 			var uri = null;
  		try {
  			pdir = parentDir.QueryInterface(Components.interfaces.nsIAbDirectory);
   			uri = pdir.URI;
 				contacts = this.contactsList[uri];
  			var card = item.QueryInterface(Components.interfaces.nsIAbCard);
  			if (card.isMailList) {
	  			//list card is remove. ignore it because it is detected by directory removed event.
	  			gGCLogger.dump("list card is removed. ignore\n");
	  			return;
  			} 
  			//uri = pdir.getDirUri();
 				var abURIArr = uri.split("/");
	 			if (pdir.hasCard(card) && abURIArr.length == 4 && abURIArr[0] == "moz-abmdbdirectory:" && abURIArr[3] != "") {
	 				//removed from a mail list
	 				gGCLogger.dump("removed from a mail list. notify.\n");
	 				var me = this;
	 				var func = function(){
    				me.onItemPropertyChangedFunc(pdir, null, null, null);
	 				};
	 				setTimeout(func);
    			return;
	 			}
	 			
 				if (!contacts) {
 					gGCLogger.dump("Not a contacts directory. Ignore.\n")
 					return;
  			}
 				//clear the last modified date for the mail list
 				//if (contacts) this.updateLastModifiedDateForMailList(item, -1, contacts.account);
    		//if (!this.listening(uri) || this.syncMode != this.SYNC_MODE_INTERACTIVE) return;
/*
  			if (pdir.hasCard(card)) {
  				dump("removed from a mail list\n");
  				return;
  			}
*/
 	   		if (!this.listening(uri)) return;
 	   		if (this.syncMode == this.SYNC_MODE_BATCH) this.writeToOfflineLog(contacts, contacts.account, uri, card, "DEL", true);
	   		if (this.syncMode == this.SYNC_MODE_INTERACTIVE) contacts.removeContact(card);
				//if (contacts) contacts.removeContact(card);
  		} catch(e) {
  			try {
  				//if (!this.listening(uri) || this.syncMode != this.SYNC_MODE_INTERACTIVE) return;
  				if (!contacts) {
  					gGCLogger.dump("no contacts"+"\n");
  					return;  					
  				}
  				var mailList = item.QueryInterface(Components.interfaces.nsIAbDirectory);
   	   		if (this.syncMode == this.SYNC_MODE_BATCH) this.writeToOfflineLog(contacts, contacts.account, uri, mailList, "DEL", false);
	 	   		if (!this.listening(uri)) return;
		   		if (this.syncMode == this.SYNC_MODE_INTERACTIVE) contacts.removeGroup(mailList);
  				//if (contacts) contacts.removeGroup(mailList);
  			} catch(e) {
  				gGCLogger.dump(e);
  			}
  		}
  	} catch(e) { //address book
//  		var dir = item.QueryInterface(Components.interfaces.nsIAbMDBDirectory);
//  		var uri = dir.getDirUri();
  		var dir = parentDir.QueryInterface(Components.interfaces.nsIAbDirectory);
   		uri = dir.URI;

   		if (!this.listening(uri)) return;
 			var contacts = this.contactsList[uri];
 			if (contacts) {
 				contacts.unsync();
 				contacts.unregisterAddressBook();
 				this.contactsList[uri] = null;
 				delete this.contactsList[uri];
	  		this.stopListening(uri);
 			}
  	}
  },
  onItemPropertyChanged: function(item, property, oldValue, newValue) {
  	/*
  	var me = this;
  	var func = function() {
  		me.onItemPropertyChangedFunc(item, property, oldValue, newValue);
  	};
  	setTimeout(func);
  	*/
  	this.onItemPropertyChangedFunc(item, property, oldValue, newValue);
  },
  onItemPropertyChangedFunc: function(item, property, oldValue, newValue) {
  	gGCLogger.dump("Detect change\n");
  	if (this.syncMode == this.SYNC_MODE_READONLY) {
  		var msg = this.localeBundle.getString("gmcont.readonly_warn");
  		this.outputMessageToStatusBar(msg);
  		gGCLogger.dump("Read only mode. Ignore changes\n");
  		return;
  	}
  	if (this.lockModEvent) return;
  	try {
  		var card = item.QueryInterface(Components.interfaces.nsIAbCard);
  		var uri = "";
  		if (card.isMailList) {
  			gGCLogger.dump("list card changed. ignored.\n");
  			return;
   		} else {
   			//card = item.QueryInterface(Components.interfaces.nsIAbMDBCard);
 				//uri = card.getStringAttribute("GmBookUri");
   			card = item.QueryInterface(Components.interfaces.nsIAbCard);
   			uri = card.getProperty("GmBookUri", null);
	  	}
 			//if (card.isMailList) return;
	  	/*
	  	if (card.isMailList) {
	  		dump("mail list changed\n");
	  		throw "mail list changed";
	  	}
	  	*/
   		//if (!this.listening(uri) || this.syncMode != this.SYNC_MODE_INTERACTIVE) return;
 			var contacts = this.contactsList[uri];
 			//card without GmBookUri is not added to the batch offline log.
 			//such card has already recorded as added card. so, no problem.
	 		if (!this.listening(uri)) return;
	 		if (contacts && this.syncMode == this.SYNC_MODE_BATCH) this.writeToOfflineLog(contacts, contacts.account, uri, card, "MOD", true);
	 		if (contacts && this.syncMode == this.SYNC_MODE_INTERACTIVE) contacts.updateContact(card);
			//if (contacts) contacts.updateContact(card);
 		} catch(e) {
 			var dir = item.QueryInterface(Components.interfaces.nsIAbDirectory);
 			if (!dir.isMailList) {
 				gGCLogger.dump(e);
 				gGCLogger.dump("not maillist\n");
 				return;
 			}
	  	//dir = item.QueryInterface(Components.interfaces.nsIAbMDBDirectory);
 			//var uri = dir.getDirUri();
  		//dir = item.QueryInterface(Components.interfaces.nsIAbDirectory);
   		uri = dir.URI;

 			//get parent URI
 			var pURI = "";
 			var abURIArr = uri.split("/");
	  	if (abURIArr.length == 4 && abURIArr[0] == "moz-abmdbdirectory:" && abURIArr[3] != "") {
    			pURI = abURIArr[0] + "/" + abURIArr[1] + "/" + abURIArr[2];
  		} else {
  			gGCLogger.dump("invalid list URI\n");
  			return;
  		}

  		//if (!this.listening(pURI)) return;
 			dir = item.QueryInterface(Components.interfaces.nsIAbDirectory);
 			var contacts = this.contactsList[pURI];
 			//if (contacts) this.updateLastModifiedDateForMailList(dir, null, contacts.account);
 			//if (this.syncMode != this.SYNC_MODE_INTERACTIVE) return;
	 		if (contacts && this.syncMode == this.SYNC_MODE_BATCH) this.writeToOfflineLog(contacts, contacts.account, pURI, dir, "MOD", false);
	 		if (!this.listening(pURI)) return;
	 		if (contacts && this.syncMode == this.SYNC_MODE_INTERACTIVE) contacts.updateGroup(dir);
/*
	 		if (contacts && this.listening(pURI)) {
				contacts.updateGroup(dir);
			} else {
		  		dump("no contact!\n");
			}
*/
  	}
  },
  
  getLastModifiedDateForMailList: function(list, account) {
  	try {
  		list.QueryInterface(Components.interfaces.nsIAbDirectory);
  	} catch(e) {
  		gGCLogger.dump(e+"\n");
  		return 0;
  	}
		var name = account + "_" + list.dirName;
		if (name) {
			name = escape(name);
			name = name.replace(/\%/g,"_");
			name = name.replace(/@/g,"_");
			name = name.replace(/\./g,"_");
			return nsPreferences.getIntPref("gmcont."+name+".last_modified", 0);
		} else {
			return 0;
		}
	},

	updateLastModifiedDateForMailList: function(list, date, account) {
		try {
			list.QueryInterface(Components.interfaces.nsIAbDirectory);
		} catch(e) {
			return;
		}
		var name = list.dirName;
		if (!name) return;
		name = account + "_" + name;
		name = escape(name);
		name = name.replace(/\%/g,"_");
		name = name.replace(/@/g,"_");
		name = name.replace(/\./g,"_");
		if (date == -1) {
			try {
				this.pref.clearUserPref("gmcont."+name+".last_modified");
			} catch(e) {
			}
		} else {
			var msec = date ? date.getTime() : (new Date()).getTime();
			nsPreferences.setIntPref("gmcont."+name+".last_modified", parseInt(msec/1000));
		}
	},
	
  startSync: function(noAuth) {
	 	if (!noAuth && !this.isOnline()) {
  		var msg = this.localeBundle.getString("gmcont.go_online");
 			alert(msg);
 			return;
  	}

  	/*
 		var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].
 												getService(Components.interfaces.nsIPromptService);
  	var maxResults = nsPreferences.getIntPref("gmcont.max-results", -1);
  	if (maxResults == -1) {
  		var setup = promptService.confirm(window, 
  																			this.localeBundle.getString("gmcont.maxresults_alert_title"),
  																			this.localeBundle.getString("gmcont.maxresults_alert_msg"));
  		if (setup) {
 				window.openDialog("chrome://gmcont/content/settings.xul", "_blank", "chrome,close,titlebar,modal", "GCMaxResults");
  		} else {
 				nsPreferences.setIntPref("gmcont.max-results", 0);
  		}
  	}
  	*/
  	this.syncMode = nsPreferences.getIntPref("gmcont.sync_mode", 0);
  	gGCLogger.dump("Retrieving Google Contacts ...\n");
  	var msg = this.localeBundle.getString("gmcont.retrieving");
		this.outputMessageToStatusBar(msg);
		
		//remember prevously authed account and password
		var prevPasswdTable = new Array();
		var key;
		for (key in this.contactsList) {
			var contacts = this.contactsList[key];
			if (contacts.busy) {
				gGCLogger.dump(contacts.account+" is busy now. Abort all reload processes.\n");
				return;
			}
			prevPasswdTable[contacts.account] = contacts.passwd;
		}
		
		var inParallel = nsPreferences.getBoolPref("gmcont.reload_in_parallel", true);
  	this.pendingContacts = [];
  	var userInfo = this.getUserInfo();
  	var user = null;
  	for (user in userInfo) {
  		var sync = nsPreferences.getBoolPref("gmcont."+user+".sync", true);
  		if (!sync) {
  			gGCLogger.dump("Skip "+user+".\n");
  			this.outputMessageToStatusBar("Skip "+user);
  			continue;
  		}
  		var pass = prevPasswdTable[user] ? prevPasswdTable[user] : userInfo[user];
  		var serialNo = this.getSerialNo(user);
			//var contacts = new GCContacts(user, pass, this, !noAuth, serialNo);
  		var contacts = new GCContacts(user, pass, this, inParallel && (!noAuth), serialNo);
			if (this.contactsList[contacts.getAddressBookURI()]) {
				contacts.undoQueue = this.contactsList[contacts.getAddressBookURI()].undoQueue;
				//if (!forceReload) contacts.latest = this.contactsList[contacts.getAddressBookURI()].latest;
			}

			if (inParallel || noAuth) {
				this.contactsList[contacts.getAddressBookURI()] = contacts;
			} else {
				this.pendingContacts.push(contacts);
			}
  	}
  	
  	if (user === null) {
	  	var setup = promptService.confirm(window, 
										this.localeBundle.getString("gmcont.maxresults_alert_title"),
										this.localeBundle.getString("gmcont.no_account_err")
	  							);
	  	if (setup) {
	 			window.openDialog("chrome://gmcont/content/settings.xul", "_blank", "chrome,close,titlebar,modal", "GCAccountListBox");
	 			var that = this;
	 			var restartFunc = function() {
	 				that.startSync(noAuth);
	 			};
	 			setTimeout(restartFunc);
	 			this.outputMessageToStatusBar("");
	 			return;
	  	} else {
	 			this.outputMessageToStatusBar("");
	 			return;
	  	}
  	}
  	
  	gGCLogger.dump("First sync done: "+this.firstSyncDone+"\n");
  	gGCLogger.dump("Sync mode: "+this.syncMode+"\n");
  	if (!this.firstSyncDone && this.syncMode != this.SYNC_MODE_READONLY) {
  		gGCLogger.dump("Add listener\n");
  		this.abSession.addAddressBookListener(
    		this,
    		Components.interfaces.nsIAbListener.all
    	);
 	  	this.firstSyncDone = true;
 	  	this.listenerWorking = true;
 		}
 		this.outputMessageToStatusBar("");
 	 	
 		//Sync now in sequential (if in parallel is true, it does nothing)
 	 	if (!noAuth) this.syncNextContacts();

 	 	if (this.timerId) clearTimeout(this.timerId);
 		var me = this;
 		var reloadFunc = function() {
			var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].
														getService(Components.interfaces.nsIWindowMediator);
			var addressbook = windowMediator.getMostRecentWindow("mail:addressbook");
			if (addressbook) addressbook.window.SelectFirstAddressBook();
 			gGCLogger.dump("Auto reload\n");
			me.startSync(); 
 		};
 		
 		var timeout = parseFloat(nsPreferences.copyUnicharPref("gmcont.auto_reload_interval", "0"));
 		if (!isNaN(timeout) && timeout > 0) {
 			gGCLogger.dump("Reload contacts every "+timeout+" hours.\n");
 			this.timerId = setTimeout(reloadFunc, timeout*60*60*1000);
 		}
 		
	},
	
	syncNextContacts: function() {
		gGCLogger.dump("Sync Contacts in SEQ. Rests are "+this.pendingContacts.length+"\n");
		var contacts = this.pendingContacts.pop();
		if (contacts) {
			this.contactsList[contacts.getAddressBookURI()] = contacts;
			contacts.auth();
		}
		
		return contacts;
	},
	
	notifySyncDone: function() {
		var inParallel = nsPreferences.getBoolPref("gmcont.reload_in_parallel", false);
		var syncContacts = !inParallel && this.syncNextContacts();
		if (!syncContacts && !inParallel) {
			this.syncNextPhotos();
		}
	},
	
	getSerialNo: function(user) {
		var serialNo = nsPreferences.getIntPref("gmcont." + user + ".serialNo", null);
		if (serialNo === null) {
			var serialNos = new Array();
			var prefCount = { value: 0 };
  		var prefArray = this.pref.getChildList("", prefCount);
  		for (var i = 0; i < prefCount.value; i++) {
    		var prefName = prefArray[i];
    		try {
    			var re = new RegExp("^gmcont\..+\.serialNo");
    			if (re.test(prefName)) {
    				var num = nsPreferences.getIntPref(prefName, null);
    				if (num != null) serialNos[num] = 1;
    			}
    		} catch(e) {
    		}
			}
			
			for (var i=0; i<serialNos.length; i++) {
				if (serialNos[i] != 1) {
					serialNo = i;
					break;
				}
				serialNo = serialNos.length;
			}
			nsPreferences.setIntPref("gmcont." + user + ".serialNo", serialNo);
		}
		gGCLogger.dump("Serial: "+serialNo+"\n");
		return serialNo;
	},
	refreshAB: function() {
		if (!this.firstSyncDone) return;
		var key = "";
		for (key in this.contactsList) {
			var contacts = this.contactsList[key];
			contacts.batchMgr.init();
			contacts.refreshABCards();
		}
	},
	notifyAuthFailed: function(contacts) {
		var uri = contacts.getAddressBookURI();
		//this.contactsList[uri] = null;
		delete this.contactsList[uri];
		this.stopListening(uri);
	},
	startListening: function(uri, deep) {
		gGCLogger.dump("start listening ...\n");
		gGCLogger.dump("URI is "+uri+"\n");
		this.listeningABs[uri] = true;
		if (deep) this.listenerStopCount -= 1;
		if (deep && this.listenerStopCount == 0 && !this.listenerWorking && this.syncMode != this.SYNC_MODE_READONLY) {
 			this.abSession.addAddressBookListener(
   			this,
   			Components.interfaces.nsIAbListener.all
   		);
   		gGCLogger.dump("Add listener\n");
   		this.listenerWorking = true;
		}
	},
	stopListening: function(uri, deep) {
		gGCLogger.dump("stop listening ...\n");
		gGCLogger.dump("URI is "+uri+"\n");
		if (uri) this.listeningABs[uri] = false;
		if (deep) this.listenerStopCount += 1;
		if (deep && this.listenerStopCount == 1 && this.syncMode != this.SYNC_MODE_READONLY) {
			try {
				this.abSession.removeAddressBookListener(this);
				gGCLogger.dump("Remove listener\n");
				this.listenerWorking = false;
			} catch(e) {
			}
		}
	},
	listening: function(uri) {
		if (!uri) return false;
		else return this.listeningABs[uri];
	},
	getUserInfo: function() {
		//var passwordmanager = Components.classes["@mozilla.org/passwordmanager;1"].
    //			getService(Components.interfaces.nsIPasswordManager);
	  var passwordmanager = Components.classes["@mozilla.org/login-manager;1"]
                        .getService(Components.interfaces.nsILoginManager);
		var signons = passwordmanager.getAllLogins({});
  	//var enumerator = passwordmanager.enumerator;
  	var count = 0;
		var passTable = new Array();
		var userInfo = new Array(); //returned value
	  //while (enumerator.hasMoreElements()) {
		for (var i=0; i<signons.length; i++) {
	    /*
 	    var nextPassword;
	    try {
	      nextPassword = enumerator.getNext();
	    } catch(e) {
	    	dump(e+"\n");
	      return userInfo;
	    }
	    */
			var nextPassword = signons[i];
	    //nextPassword = nextPassword.QueryInterface(Components.interfaces.nsIPassword);
	    var host = nextPassword.hostname;
	    var user;
	    var password;
	    // try/catch in case decryption fails (invalid signon entry)
	    try {
	      //user = nextPassword.user;
	    	user = nextPassword.username;
	      password = nextPassword.password;
	    } catch (e) {
	      // hide this entry
	      gGCLogger.dump("could not decrypt user/password for host " + host + "\n");
	      continue;
	    }

	    //retrieve user info from host URI
/*
	    if (!user) {
				var uriParts = host.split("://");
	    	try {
					uriParts = uriParts[1].split("@");
	    	} catch(e) {
	    	}
				user = decodeURIComponent(uriParts[0]);
	    }
*/
	    if (host == 'chrome://gmcont/'+user) {
	   		passTable[user] = password;
	    } else if (user && !passTable[user]) {
	    	passTable[user] = password;
	    }
	  }
	
		var am = Components.classes["@mozilla.org/messenger/account-manager;1"].
			getService(Components.interfaces.nsIMsgAccountManager);
		var allServers=am.allServers;
		var serverCount = allServers.Count();
		for (var i = 0; i < serverCount; i++) {
			var server = allServers.QueryElementAt(i, Components.interfaces. nsIMsgIncomingServer);
			//not email
			if (server.type == "nntp" || server.type == "rss" || server.type == "none") continue;
			//not google
			var hostName = server.realHostName ? server.realHostName : server.hostName;
			if (!hostName.match(/(?:g|google)mail\.com$/)) continue;
		  var user = server.realUsername ? server.realUsername : server.username;
		  if (user.indexOf("@") < 0) {
		  	var hostParts = hostName.split(".");
		  	user = user + "@"
		  			 + hostParts[hostParts.length - 2] 
		  			 + "." + hostParts[hostParts.length - 1];
		 	}
			user = user.replace(/^recent:/,"");
	  	var password = passTable[user];
	  	if (!password) password = server.password; //can retrieve password if the server is already authed
			userInfo[user] = password;
		}
		
		var customAccounts = nsPreferences.copyUnicharPref("gmcont.custom_accounts", null);
		if (customAccounts) {
			var accounts = customAccounts.split(",");
			for (var i=0; i<accounts.length; i++) {
				var account = accounts[i];
				userInfo[account] = passTable[account];
			}
		}
		return userInfo;
	},
	
	init: function(aEvent) {
		if (!aEvent || this.initDone) return;
		var doc = aEvent.originalTarget;
		if (doc.location && doc.location.protocol == "chrome:") {
			this.localeBundle = document.getElementById("GmContBundle");
			var os = Components.classes["@mozilla.org/observer-service;1"]
    		        .getService(Components.interfaces.nsIObserverService);
			os.addObserver(this, "network:offline-status-changed", false);
			this.initDone = true;
			//var authAtStartup = nsPreferences.getBoolPref("gmcont.auth_at_startup", true);
			var authAtStartup = nsPreferences.getBoolPref("gmcont.auth_at_startup", null);
			var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].
													getService(Components.interfaces.nsIPromptService);
			if (authAtStartup === null) {
	  		authAtStartup = promptService.confirm(window, 
										"Google Contacts setting",
										"Do you want to reload contacts at startup?"
	  							);
	  		nsPreferences.setBoolPref("gmcont.auth_at_startup", authAtStartup);
			}
			//if (!authAtStartup) return;
			//wait until messenger is loaded
			var me = this;
			var func = function() {
				var folderTree = document.getElementById("folderTree");
				if (folderTree) me.startSync(!authAtStartup);
				//if (gNotifyDefaultInboxLoadedOnStartup) me.startSync();
				else setTimeout(func, 1000);
			};
			setTimeout(func, 1000);
			
			this.photoManager = {};
			var loader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"]
										.getService(Components.interfaces.mozIJSSubScriptLoader);
			loader.loadSubScript("chrome://messenger/content/addressbook/abCommon.js", this.photoManager);
			loader.loadSubScript("chrome://messenger/content/addressbook/abCardOverlay.js", this.photoManager);
		}
	},
  isOnline: function() {
    var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                           .getService(Components.interfaces.nsIIOService);
    return (!ioService.offline);
  },
	observe: function (aSubject, aTopic, aState) {
    if (aTopic == "network:offline-status-changed") {
    	if (this.isOnline() && !this.updatedFromOffline) {
    		this.updatedFromOffline = true;
				//var authAtStartup = nsPreferences.getBoolPref("gmcont.auth_at_startup", true);
				var reloadAtOnline = nsPreferences.getBoolPref("gmcont.reload_at_online",false);
      	//this.startSync(!authAtStartup);
      	this.startSync(!reloadAtOnline);
    	} else {//offline or already updated
    		/*
    		try {
    		 	this.abSession.addAddressBookListener(
    				this,
    				Components.interfaces.nsIAddrBookSession.all
    			);
    		} catch(e) {
    			dump(e);
    		}
    		*/
    		this.updatedFromOffline = this.isOnline();
    		if (this.timerId && !this.isOnline()) clearTimeout(this.timerId);
    	}
  	}
  },
  outputMessageToStatusBar: function(str) {
		var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].
													getService(Components.interfaces.nsIWindowMediator);
		try {
			var messenger = windowMediator.getMostRecentWindow("mail:3pane");
			if (messenger) messenger.document.getElementById("statusText").setAttribute("label",str);

			var addressbook = windowMediator.getMostRecentWindow("mail:addressbook");
			if (addressbook) addressbook.document.getElementById("statusText").setAttribute("label",str);
		} catch(e) {
			gGCLogger.dump(e+"\n");
		}
	},
	progressStart: function() {
		if (this.queueNum == 0) {
			MsgStatusFeedback.startMeteors();
			try {
				var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].
															getService(Components.interfaces.nsIWindowMediator);
				var addressbook = windowMediator.getMostRecentWindow("mail:addressbook");
				if (addressbook) {
					addressbook.gGCContactManagerAB.progressStart();
				}
			} catch(e) {}
		}
		this.queueNum++;
	},
	progressEnd: function() {
		this.queueNum--;
		if (this.queueNum == 0) {
			MsgStatusFeedback.stopMeteors();
			try {
				var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].
															getService(Components.interfaces.nsIWindowMediator);
				var addressbook = windowMediator.getMostRecentWindow("mail:addressbook");
				if (addressbook) {
					addressbook.gGCContactManagerAB.progressEnd();
				}
			} catch(e) {}
		}
	},
	getDeletedEntries: function() {
		var entries = new Array();
		var key;
		for (key in this.contactsList) {
			var contacts = this.contactsList[key];
			entries[contacts.account] = contacts.getDeletedEntries();
		}
		return entries;
	},
	undoDeletedEntry: function(account, index) {
		var contacts = null;
		var key;
		for (key in this.contactsList) {
			contacts = this.contactsList[key];
			if (contacts.account == account) break;
		}
		if (contacts) contacts.undoDeletedEntry(index);
	},
	removeAllCache: function() {
		if (!nsPreferences.getBoolPref("gmcont.remove_disk_cache_on_finish", true)) return;
		
		var backupMgr = new GCBackupManager();
		var file = backupMgr.getCacheDir();

		if (file && file.exists()) {
			file.remove(true);
		}
	},
	
	clearBatchLog: function(account) {
		var backupMgr = new GCBackupManager();
		var file = backupMgr.getDumpDir(account);
		if (!file) return;
		
		file.append("offline.log");
		if (file.exists()) file.remove(false);
	},
	
	getOfflineChanges: function(account, clearLog) {
		var file = null;
		var records = new Array();

		var backupMgr = new GCBackupManager();
		var file = backupMgr.getDumpDir(account);
		if (!file) return records;
		file.append("offline.log");
		if (!file.exists()) return records;
		
		var istream = Components.classes["@mozilla.org/network/file-input-stream;1"]
                        .createInstance(Components.interfaces.nsIFileInputStream);

		istream.init(file, 0x01, 0444, 0);
		istream.QueryInterface(Components.interfaces.nsIInputStream);
		var cistream = Components.classes["@mozilla.org/intl/converter-input-stream;1"]
                   .createInstance(Components.interfaces.nsIConverterInputStream);

		cistream.init(istream, "UTF-8", 1024, 0xFFFD);
		cistream.QueryInterface(Components.interfaces.nsIUnicharLineInputStream);
		var line = {}, hasmore;
		do {
  		hasmore = cistream.readLine(line);
  		var fields = (line.value).split("%%GCSEP%%");
  		var record = {
  			id: fields[0],
  			type: fields[1],
  			operation: fields[2],
  			date: fields[3] 
  		};
  		records.push(record);
		} while(hasmore);

		istream.close();
		cistream.close();
		
		if (clearLog) file.remove(false);
		
		return records;
	},
	
	writeToOfflineLog: function(contacts, account, abURI, item, operation, isCard) {
		var str = "";
		var type = "";
		var id = "";
		var addrBookDir = contacts.getAddressBook();
		var msec = (new Date()).getTime();
		msec = parseInt(msec/1000);
		gGCLogger.dump("Offline "+operation+"\n");
		if (isCard) {
			type = "card";
			var id = "ID" + msec + this.batchCount;
			//var	card = item.QueryInterface(Components.interfaces.nsIAbMDBCard);
			var	card = item.QueryInterface(Components.interfaces.nsIAbCard);
			switch (operation) {
				case "ADD":
					this.lockModEvent = true;
					//card.setStringAttribute("GmOfflineId", id);
					card.setProperty("GmOfflineId", id);
					addrBookDir.modifyCard(card);
   				//card = card.QueryInterface(Components.interfaces.nsIAbCard);
 					//card.editCardToDatabase(abURI);
 					this.lockModEvent = false;
 					break;
				case "MOD":
					//id = card.getStringAttribute("GmContactId");
					id = card.getProperty("GmContactId", null);
					if (!id) return false; //update for newly added cards. no need to record.
					break;
				case "DEL":
					id = card.getProperty("GmContactId", null);
					gGCLogger.dump("Card ID: "+id+"\n");
					if (!id) return false; //update for newly added cards. no need to record.
					/*
					var email = card.getProperty("PrimaryEmail", null);
					var name = card.getProperty("DisplayName", null);
					dump("Card ID: "+card.getProperty("GmContactId", null)+"\n");
					//if (name) name = name.replace(/@/g,"%%GCAT%%");
					if (!email) email = "";
					if (!name) name = "";
					//id = email ? email : name;
					id = email+name;
					*/
					break;
			}
		} else {
			type = "list";
	  	//var dir = item.QueryInterface(Components.interfaces.nsIAbMDBDirectory);
  		var dir = item.QueryInterface(Components.interfaces.nsIAbDirectory);
	  	switch (operation) {
	  		case "ADD": case "MOD":
		   		id = dir.URI;
		 			//id = dir.getDirUri();
		 			break;
		 		case "DEL":
					try {
		 				var uri = dir.URI;
		 				gGCLogger.dump("Dir ID: "+uri+"\n");
		   			id = nsPreferences.copyUnicharPref("gmcont."+account+"."+uri+".groupId", null);
		   			gGCLogger.dump("Group ID: "+id+"\n");
		   			if (!id) return false;
//		 			id = dir.dirName;
					} catch(e) {
						gGCLogger.dump("Cannot get nsIAbDirectory.URI\n");
						return false;
					}
		 			break;
	  	}
		}

		var str = id + "%%GCSEP%%"
						+ type + "%%GCSEP%%"
						+ operation + "%%GCSEP%%"
						+ msec + "\n";

		var backupMgr = new GCBackupManager();
		var file = backupMgr.getDumpDir(account);
		if (!file) return false;

		file.append("offline.log");
		if (!file.exists()) file.create(file.NORMAL_FILE_TYPE, 0666);
		
		var fileStream = Components.classes['@mozilla.org/network/file-output-stream;1']
											.createInstance(Components.interfaces.nsIFileOutputStream);
		//fileStream.init(file, 0x10|0x40, 0x200, false); //PR_APPEND: 0x10, PR_SYNC: 0x40
		fileStream.init(file, 0x02 | 0x10, 0x200, false); //PR_APPEND: 0x10, PR_SYNC: 0x40
		
		var converterStream = Components
				.classes['@mozilla.org/intl/converter-output-stream;1']
				.createInstance(Components.interfaces.nsIConverterOutputStream);
				
		try {										 
			converterStream.init(fileStream, "UTF-8", 0,
												 Components.interfaces.nsIConverterInputStream.DEFAULT_REPLACEMENT_CHARACTER);
			converterStream.writeString(str);
		} catch(e) {
			gGCLogger.dump(e);
			return false;
		}
	
		converterStream.close();
		fileStream.close();
		this.batchCount++;
		return true;
		
	},
	
	reloadPhotos: function() {
		var inParallel = nsPreferences.getBoolPref("gmcont.reload_in_parallel", false);
		this.pendingContactsForPhotos = [];
		var key;
		if (inParallel) {
			gGCLogger.dump("Reload photos in parallel\n");
			for (key in this.contactsList) {
				gGCLogger.dump(key+"\n");
				var contacts = this.contactsList[key];
				contacts.retrievePhotoAll();
			}
		} else {
			for (key in this.contactsList) {
				var contacts = this.contactsList[key];
				this.pendingContactsForPhotos.push(contacts);
			}
			this.syncNextPhotos();
		}
	},
	
	uploadPhoto: function(card, imageURI) {
		var abURI = card.getProperty("GmBookUri", null);
		var contacts = this.contactsList[abURI];
  	if (!contacts) return;
  	contacts.uploadPhoto(card, imageURI);
	},
	
	uploadPhotos: function(cards, abURI) {
		var contacts = this.contactsList[abURI];
  	if (!contacts) return;
  	contacts.uploadPhoto(cards, null);
	},
	
	deletePhoto: function(card) {
		var abURI = card.getProperty("GmBookUri", null);
		var contacts = this.contactsList[abURI];
  	if (!contacts) return;
  	contacts.removePhoto(card);
	},

	deletePhotos: function(cards, abURI) {
		var contacts = this.contactsList[abURI];
  	if (!contacts) return;
  	contacts.removePhoto(cards);
	},
	
	syncNextPhotos: function() {
		gGCLogger.dump("Sync Photos in SEQ. Rests are "+this.pendingContactsForPhotos.length+"\n");
		var contacts = this.pendingContactsForPhotos.pop();
		if (contacts) {
			contacts.retrievePhotoAll();
		}
		
		return contacts;
	},
	
	toRFC3339: function(aDate) {
		var date = aDate ? aDate : new Date();
		var str = date.getUTCFullYear()                         
						+ "-" + ("0"+(date.getUTCMonth()+1)).substr(-2)
						+ "-" + ("0"+date.getUTCDate()).substr(-2)
						+ "T" + ("0"+date.getUTCHours()).substr(-2)
						+ ":"	+ ("0"+date.getUTCMinutes()).substr(-2)
						+ ":" + ("0"+date.getUTCSeconds()).substr(-2)
						+ "."	+ ("00"+date.getUTCMilliseconds()).substr(-3)
						+ "Z";
						
		return str;
	},
	
	getContactSource: function(abCard) {
		var uri = abCard.getProperty("GmBookUri", null);
		var id = abCard.getProperty("GmContactId", null);
		if (!uri || !id) return null;
 		var contacts = this.contactsList[uri];
 		var contact = contacts.contacts[id];
 		if (contact) {
 			return contact.toXMLString();	
 			//return contact.toString();	
 		} else {
			//load cache if available
 			contact = new GCContactEntry();
 			contact.setCacheFileName(id);
 			if (contact.loadCache()) return "<!-- This source is loaded from cache. It may not be the latest. -->\n" + contact.toXMLString();
 			//return null;
 		}
 		
 		return null;
	},
	
	openWebInTab: function() {
		document.getElementById('tabmail').openTab(
			'contentTab',
			{contentPage:'https://www.google.com/contacts',
			 background: false, 
  			clickHandler: "specialTabs.siteClickHandler(event, /google\\.com\\//)"
  		});
	}
};

